/*
Freecalc2000  .  1.22  11.01.01

     
 ;      \ 
     GNU, 
"Free Software Foundation" -     2,  ( 
)     .

   ,     
,     ,   
  -     
(. "   GNU").

         "
  GNU";    ,   Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

E-mail: e-vasil@yandex.ru
Web: winapi32.narod.ru 
*/

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <setjmp.h>
#include <shellapi.h>
#include "freecalcres.h"
#include "calc.h"

#define MYWM_NOTIFYICON WM_USER+101


HINSTANCE hinst;
HICON hIconCalc;
NOTIFYICONDATA tnid;
HWND hwndDlg;
MSG msg;
HANDLE hAccelTable;
HWND hMenu;
LRESULT  r;
HGLOBAL hglbCopy;
LPTSTR strCopy;



Evaluate( char* e, TYPE* result, int* a );
LRESULT CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hinst, HINSTANCE hinstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wc;
	memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = DefDlgProc;
	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.hInstance = hinst;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = "freecalc";
	RegisterClass(&wc);

	hIconCalc=LoadIcon(hinst,"calc");
	hAccelTable = LoadAccelerators(hinst,MAKEINTRESOURCE(IDACCEL));
	hwndDlg=CreateDialog(hinst, MAKEINTRESOURCE(IDD_MAINDIALOG), NULL, (DLGPROC)DialogFunc);

	while (GetMessage(&msg,NULL,0,0))
		{
		if (!TranslateAccelerator(hwndDlg,hAccelTable,&msg))
			{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			}
		}

	return msg.wParam;

}

LRESULT CALLBACK DialogFunc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	char data[512];
	double result;
	int ercode;
	char sxPos[128],syPos[128];
	int xPos,yPos;
	RECT wPos;
	char IniFileName[1024];

	switch (msg)
	{

	case WM_INITDIALOG:
		tnid.cbSize = sizeof(NOTIFYICONDATA);
		tnid.hWnd = hwndDlg;
		tnid.uID = 505;
		tnid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
		tnid.uCallbackMessage = MYWM_NOTIFYICON;
		tnid.hIcon = hIconCalc;
		lstrcpyn(tnid.szTip, "FreeCalc2000", sizeof(tnid.szTip));
    	Shell_NotifyIcon(NIM_ADD, &tnid);
		GetCurrentDirectory(1024,IniFileName);
		wsprintf(IniFileName,"%s\\freecalc.ini",IniFileName);
		xPos=GetPrivateProfileInt("Options","xPos",0,IniFileName);
		yPos=GetPrivateProfileInt("Options","yPos",0,IniFileName);
		SetWindowPos(hwndDlg,HWND_TOP,xPos,yPos,0,0,SWP_NOSIZE);
		break;

	case MYWM_NOTIFYICON:
		switch (lParam)
		{
		case WM_LBUTTONDOWN:
		ShowWindow(hwndDlg,SW_SHOW);
		SetForegroundWindow(hwndDlg);
		return 0;
		}
		break;

	case WM_EXITSIZEMOVE:
		GetWindowRect(hwndDlg,&wPos);
		wsprintf(sxPos,"%i",wPos.left);
		wsprintf(syPos,"%i",wPos.top);

		GetCurrentDirectory(1024,IniFileName);
		wsprintf(IniFileName,"%s\\freecalc.ini",IniFileName);
		WritePrivateProfileString ("Options","xPos",sxPos,IniFileName);
		WritePrivateProfileString ("Options","yPos",syPos,IniFileName);
		break;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{

		case ID_CALC:
			SendDlgItemMessage(hwndDlg,IDE_DATA,WM_GETTEXT,(WPARAM)1024,(LPARAM)data);
			Evaluate(data,&result,&ercode);
			sprintf(data,"%.12g",result);
			SendDlgItemMessage(hwndDlg,IDE_DATA,WM_SETTEXT,(WPARAM)0,(LPARAM)data);
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_SETSEL,(WPARAM)0,(LPARAM)-1);

			//     

			OpenClipboard(hwndDlg);
			EmptyClipboard();
			hglbCopy = GlobalAlloc(GMEM_DDESHARE,512);
			strCopy = GlobalLock(hglbCopy);
        	memcpy(strCopy,data,512);
        	GlobalUnlock(hglbCopy);
			SetClipboardData(CF_TEXT, hglbCopy);
			CloseClipboard();


		break;

		case ID_HIDE:
			ShowWindow(hwndDlg,SW_HIDE);
		break;

		case ID_FUNC:
			GetWindowRect(hwndDlg,&wPos);
			hMenu = LoadMenu (hinst,"PopMenu") ;
			hMenu = GetSubMenu (hMenu, 0) ;
			TrackPopupMenuEx (hMenu,TPM_VERTICAL,wPos.left,wPos.top,hwndDlg,NULL);
			DestroyMenu(hMenu);
		break;

		case IDM_EXIT:
			Shell_NotifyIcon(NIM_DELETE,&tnid);
			EndDialog(hwndDlg,0);
			PostQuitMessage(0);
		break;

		case IDM_SIN:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"sin(");
		break;

		case IDM_COS:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"cos(");
		break;

		case IDM_TAN:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"tan(");
		break;

		case IDM_ASIN:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"asin(");
		break;

		case IDM_ACOS:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"acos(");
		break;

		case IDM_ATAN:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"atan(");
		break;

		case IDM_EXP:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"exp(");
		break;

		case IDM_LOG:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"log(");
		break;

		case IDM_LOG10:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"log10(");
		break;

		case IDM_SQRT:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"sqrt(");
		break;

		case IDM_ABS:
			SendDlgItemMessage(hwndDlg,IDE_DATA,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)"abs(");
		break;

		}
		break;

		case WM_SYSCOMMAND:
			switch (LOWORD(wParam))

				{
					case SC_CLOSE:
						ShowWindow(hwndDlg,SW_HIDE);
				}
		break;

	}
return FALSE;

}

